import TransportFactory from "./TransportFactory";
import ITransport from "./Transport";
import Truck from "../Transports/Truck";
import Ship from "../Transports/Ship";
import Airplan from "../Transports/Airplane";
import Moto from "../Transports/Moto";

export class TruckCreator extends TransportFactory {
    public factoryMethod(): ITransport {
      return new Truck();  
    };
};

export class ShipCreator extends TransportFactory {
    public factoryMethod(): ITransport {
        return new Ship();
    };
};

export class AirplanCreator extends TransportFactory {
    public factoryMethod(): ITransport {
        return new Airplan();
    };
};

export class MotoFactory extends TransportFactory {
    public factoryMethod(): ITransport {
        return new Moto();
    };
};