import AddStrategy from "./Strategy/AddStrategy";
import MultiplyStrategy from "./Strategy/MultiplyStrategy";
import IStrategy from "./Strategy/Strategy";

class Context {
  private _strategy!: IStrategy;

  public setStrategy(strategy: IStrategy): void {
    this._strategy = strategy;
  }

  execute(a: number, b: number): number {
    return this._strategy.execute(a, b);
  }
}

const addNumber = new Context();
addNumber.setStrategy(new MultiplyStrategy());
const res = addNumber.execute(4, 4);
console.log(res)